from ctypes import *
import os
from SimulyzerConstants import *
import threading

rdy_flag = threading.Event()

def py_callcack(v_p):
    print "Stream complete"
    rdy_flag.set()
    return

CMPFUNC = WINFUNCTYPE(None,c_void_p)
cb_func = CMPFUNC(py_callcack)
callback_ctx = c_void_p()


#provide twenty(20) buffers with downsampled data
bufferCount = 20
sampleCnt = (c_int * bufferCount)()           #hold the valid count of sample buffer
sampleBuffers = (c_void_p * bufferCount)()    #array to store the buffer adresses 

for n in range(0,bufferCount):
    sampleCnt[n] = 300;                              #set sample count
    buff = (c_double * 3000)()
    for k in range(0,2999):
        buff[k] = (n + 1) * 10
    sampleBuffers[n] = cast(pointer(buff),c_void_p)  #store buffer address
    buff[sampleCnt[n] - 1] = 0                       #set stream data back to zero
        
#load the simulyzer library
os.chdir("./tmp")
hnd = cdll.LoadLibrary("../Simulyzer_64.dll")
print hnd

#create a system handle from system configuration file
syshnd = c_void_p()
sekRetVal = hnd.StartLogging("simu.log",c_int(LoggingWhat['TRACE_APICALLS']+LoggingWhat['TRACE_ERROR']),c_int(LoggingHow['MODE_REOPEN']+LoggingHow['MODE_CONSOLE_OUT']))
print "StartLogging return code: " + str(sekRetVal)

sekRetVal = hnd.SimulyzerSystemCreate(byref(syshnd),"../ExampleSystemConfig.xml")
print "SimulyzerSystemCreate return code: " + str(sekRetVal)
#read back the actual count of initialized simulyzer devices (only for testing)
devCount = c_int(10)
devHnd = (c_void_p * 10)()
hnd.SimulyzerSystemGetDevices(syshnd,byref(devCount),pointer(devHnd))
print devCount
sekRetVal = hnd.SimulyzerSystemSetStreamEndCallback(syshnd,callback_ctx,cb_func)
print "SimulyzerSystemSetStreamEndCallback return code: " + str(sekRetVal)


#set the data for streaming
hnd.SimulyzerSystemSetSignalData(syshnd,bufferCount,pointer(sampleCnt),pointer(sampleBuffers),1)
#set trigger signal
raw_input("return to continue")
rdy_flag.clear()
hnd.SimulyzerSystemStartStream(syshnd)
rdy_flag.wait(2.0)
print rdy_flag.isSet()

#cleanup all simulyzer stuff
hnd.SimulyzerSystemDestroy(syshnd)
