from ctypes import *
import os
from SimulyzerConstants import *
import threading

rdy_flag = threading.Event()

def py_callcack(v_p):
    print "Stream complete"
    rdy_flag.set()
    return

CMPFUNC = WINFUNCTYPE(None,c_void_p)
cb_func = CMPFUNC(py_callcack)
callback_ctx = c_void_p()


#load the simulyzer library
os.chdir("./tmp")
hnd = cdll.LoadLibrary("../Simulyzer_64.dll")
print hnd

#create a system handle from system configuration file
syshnd = c_void_p()
sekRetVal = hnd.StartLogging("simu.log",c_int(LoggingWhat['TRACE_APICALLS']+LoggingWhat['TRACE_ERROR']),c_int(LoggingHow['MODE_REOPEN']+LoggingHow['MODE_CONSOLE_OUT']))
print "StartLogging return code: " + str(sekRetVal)

sekRetVal = hnd.SimulyzerSystemCreate(byref(syshnd),"../ExampleSystemConfigCSVImport.xml")
print "SimulyzerSystemCreate return code: " + str(sekRetVal)
#read back the actual count of initialized simulyzer devices (only for testing)
devCount = c_int(10)
devHnd = (c_void_p * 10)()
hnd.SimulyzerSystemGetDevices(syshnd,byref(devCount),pointer(devHnd))
print devCount
sekRetVal = hnd.SimulyzerSystemSetStreamEndCallback(syshnd,callback_ctx,cb_func)
print "SimulyzerSystemSetStreamEndCallback return code: " + str(sekRetVal)


#set the data for streaming
hnd.SimulyzerSystemSetSignalDataFromCSV(syshnd,"../data/2kHz.csv",1)
#hnd.SimulyzerSystemSetSignalDataFromCSV(syshnd,"../data/crash1.csv",1)
#set trigger signal
raw_input("return to continue")
rdy_flag.clear()
hnd.SimulyzerSystemStartStream(syshnd)
rdy_flag.wait(2.0)
print rdy_flag.isSet()

#cleanup all simulyzer stuff
hnd.SimulyzerSystemDestroy(syshnd)
